%define nightly @NIGHTLY_VERSION@%{nil}
%define _sysconfdir %{_prefix}/etc
%define release 1
%define configure_opts --enable-openmp --enable-mpi MPICC=/usr/lib64/openmpi/bin/mpicc GSL_LIBS="-lgsl"

%if "%{?nightly:%{nightly}}%{!?nightly:0}" == "%{nil}"
%undefine nightly
%endif

# borrowed from python3-rpm-macros
%define pyYdir %{_builddir}/pythonY-%{name}-%{version}-%{release}

# -- metadata ---------------

Name: @PACKAGE@
Version: @BASE_VERSION@
Release: %{?nightly:0.%{nightly}}%{!?nightly:%{release}}%{?dist}
Summary: LSC Algorithm Inference Library
License: GPLv2+
Group: LAL
Source0: http://software.ligo.org/lscsoft/source/lalsuite/%{name}-%{version}%{?nightly:-%{nightly}}.tar.xz
URL: https://wiki.ligo.org/Computing/LALSuite
Packager: Adam Mercer <adam.mercer@ligo.org>
Prefix: %{_prefix}

# -- build requirements -----

# C
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: gsl-devel
BuildRequires: help2man >= 1.37
BuildRequires: liblal-devel >= @MIN_LAL_VERSION@
BuildRequires: liblalframe-devel >= @MIN_LALFRAME_VERSION@
BuildRequires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@
BuildRequires: liblalsimulation-devel >= @MIN_LALSIMULATION_VERSION@
BuildRequires: liblalburst-devel >= @MIN_LALBURST_VERSION@
BuildRequires: liblalinspiral-devel >= @MIN_LALINSPIRAL_VERSION@
BuildRequires: liblalpulsar-devel >= @MIN_LALPULSAR_VERSION@
BuildRequires: make
BuildRequires: openmpi-devel
BuildRequires: pkgconfig >= 0.18.0

# swig
BuildRequires: swig >= @MIN_SWIG_VERSION@

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
BuildRequires: python2-rpm-macros
BuildRequires: python
BuildRequires: python-devel
BuildRequires: python2-astropy >= 1.1.1
BuildRequires: python2-glue >= @MIN_GLUE_VERSION@
BuildRequires: python2-gwdatafind
BuildRequires: python2-gwpy
BuildRequires: healpy >= 1.9.1
BuildRequires: python2-h5py
BuildRequires: python2-lal >= @MIN_LAL_VERSION@
BuildRequires: python2-lalmetaio >= @MIN_LALMETAIO_VERSION@
BuildRequires: python2-lalsimulation >= @MIN_LALSIMULATION_VERSION@
BuildRequires: python2-lalburst >= @MIN_LALBURST_VERSION@
BuildRequires: python2-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
BuildRequires: python2-lalpulsar >= @MIN_LALPULSAR_VERSION@
BuildRequires: python2-matplotlib >= 1.2.0
BuildRequires: python2-mock
BuildRequires: python2-numpy >= @MIN_NUMPY_VERSION@
BuildRequires: python-pathlib
BuildRequires: pytest
BuildRequires: python2-scipy >= 0.9.0
BuildRequires: rsync
%endif

# python3x
BuildRequires: python-srpm-macros
BuildRequires: python3-rpm-macros
BuildRequires: epel-rpm-macros
BuildRequires: python%{python3_pkgversion}
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-astropy >= 1.1.1
BuildRequires: python%{python3_pkgversion}-gwdatafind
BuildRequires: python%{python3_pkgversion}-gwpy
BuildRequires: python%{python3_pkgversion}-glue >= @MIN_GLUE_VERSION@
BuildRequires: python%{python3_pkgversion}-healpy >= 1.9.1
BuildRequires: python%{python3_pkgversion}-h5py
BuildRequires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
BuildRequires: python%{python3_pkgversion}-lalmetaio >= @MIN_LALMETAIO_VERSION@
BuildRequires: python%{python3_pkgversion}-lalsimulation >= @MIN_LALSIMULATION_VERSION@
BuildRequires: python%{python3_pkgversion}-lalburst >= @MIN_LALBURST_VERSION@
BuildRequires: python%{python3_pkgversion}-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
BuildRequires: python%{python3_pkgversion}-lalpulsar >= @MIN_LALPULSAR_VERSION@
BuildRequires: python%{python3_pkgversion}-matplotlib >= 1.2.0
BuildRequires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
BuildRequires: python%{python3_pkgversion}-pytest
BuildRequires: python%{python3_pkgversion}-scipy >= 0.9.0

# octave
BuildRequires: octave-devel
BuildRequires: lal-octave >= @MIN_LAL_VERSION@
BuildRequires: lalframe-octave >= @MIN_LALFRAME_VERSION@
BuildRequires: lalmetaio-octave >= @MIN_LALMETAIO_VERSION@
BuildRequires: lalsimulation-octave >= @MIN_LALSIMULATION_VERSION@
BuildRequires: lalburst-octave >= @MIN_LALBURST_VERSION@
BuildRequires: lalinspiral-octave >= @MIN_LALINSPIRAL_VERSION@
BuildRequires: lalpulsar-octave >= @MIN_LALPULSAR_VERSION@

# -- packages ---------------

# lalinference
Requires: lib%{name} = %{version}-%{release}
Requires: python%{python3_pkgversion}-%{name} = %{version}-%{release}
%description
The LSC Algorithm Inference Library for gravitational wave data analysis.

# liblalinference
%package -n lib%{name}
Summary: LSC Algorithm Inference Library - library package
Requires: gsl >= 1.15
Requires: openmpi
Requires: openssh-clients
Requires: liblal >= @MIN_LAL_VERSION@
Requires: liblalframe >= @MIN_LALFRAME_VERSION@
Requires: liblalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: liblalsimulation >= @MIN_LALSIMULATION_VERSION@
Requires: liblalburst >= @MIN_LALBURST_VERSION@
Requires: liblalinspiral >= @MIN_LALINSPIRAL_VERSION@
Requires: liblalpulsar >= @MIN_LALPULSAR_VERSION@
Conflicts: %{name} <= 2.0.5-1
%description -n lib%{name}
The LSC Algorithm Inference Library for gravitational wave data analysis.
This package contains the shared-object libraries needed to run applications
that use the LAL Inference library.

# liblalinference-devel
%package -n lib%{name}-devel
Summary: Files and documentation needed for compiling programs that use LAL Inference
Group: LAL
Requires: gsl-devel >= 1.15
Requires: lib%{name} = %{version}-%{release}
Requires: liblal-devel >= @MIN_LAL_VERSION@
Requires: liblalframe-devel >= @MIN_LALFRAME_VERSION@
Requires: liblalmetaio-devel >= @MIN_LALMETAIO_VERSION@
Requires: liblalsimulation-devel >= @MIN_LALSIMULATION_VERSION@
Requires: liblalburst-devel >= @MIN_LALBURST_VERSION@
Requires: liblalinspiral-devel >= @MIN_LALINSPIRAL_VERSION@
Requires: liblalpulsar-devel >= @MIN_LALPULSAR_VERSION@
Provides: %{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel < %{version}-%{release}
%description -n lib%{name}-devel
The LSC Algorithm Inference Library for gravitational wave data analysis. This
package contains files needed build applications that use the LAL Inference
library.

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2-lalinference
%package -n python2-%{name}
Summary: Python %{python2_version} Bindings for LALInference
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: healpy >= 1.9.1
Requires: python
Requires: python2-astropy >= 1.1.1
Requires: python2-glue >= @MIN_GLUE_VERSION@
Requires: python2-gwdatafind
Requires: python2-gwpy
Requires: python2-h5py
Requires: python2-lal >= @MIN_LAL_VERSION@
Requires: python2-lalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: python2-lalsimulation >= @MIN_LALSIMULATION_VERSION@
Requires: python2-lalburst >= @MIN_LALBURST_VERSION@
Requires: python2-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
Requires: python2-lalpulsar >= @MIN_LALPULSAR_VERSION@
Requires: python2-ligo-gracedb
Requires: python2-ligo-lw
Requires: python2-ligo-segments
Requires: python2-matplotlib >= 1.2.0
Requires: python2-numpy >= @MIN_NUMPY_VERSION@
Requires: python2-scipy >= 0.8
Requires: python2-six
Provides: %{name}-python = %{version}-%{release}
Provides: deprecated()
Obsoletes: %{name}-python < %{version}-%{release}
%{?python_provide:%python_provide python2-%{name}}
%description -n python2-%{name}
The LSC Algorithm Library for gravitational wave data analysis.
This package provides the Python %{python2_version} bindings for LALInference.
%endif

# python3x-lalinference
%package -n python%{python3_pkgversion}-%{name}
Summary: Python %{python3_version} Bindings for LALInference
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: python%{python3_pkgversion}
Requires: python%{python3_pkgversion}-astropy >= 1.1.1
Requires: python%{python3_pkgversion}-glue >= @MIN_GLUE_VERSION@
Requires: python%{python3_pkgversion}-gwdatafind
Requires: python%{python3_pkgversion}-gwpy
Requires: python%{python3_pkgversion}-healpy >= 1.9.1
Requires: python%{python3_pkgversion}-h5py
Requires: python%{python3_pkgversion}-lal >= @MIN_LAL_VERSION@
Requires: python%{python3_pkgversion}-lalmetaio >= @MIN_LALMETAIO_VERSION@
Requires: python%{python3_pkgversion}-lalsimulation >= @MIN_LALSIMULATION_VERSION@
Requires: python%{python3_pkgversion}-lalburst >= @MIN_LALBURST_VERSION@
Requires: python%{python3_pkgversion}-lalinspiral >= @MIN_LALINSPIRAL_VERSION@
Requires: python%{python3_pkgversion}-lalpulsar >= @MIN_LALPULSAR_VERSION@
Requires: python%{python3_pkgversion}-ligo-gracedb
Requires: python%{python3_pkgversion}-ligo-lw
Requires: python%{python3_pkgversion}-ligo-segments
Requires: python%{python3_pkgversion}-matplotlib >= 1.2.0
Requires: python%{python3_pkgversion}-numpy >= @MIN_NUMPY_VERSION@
Requires: python%{python3_pkgversion}-scipy >= 0.8
Requires: python%{python3_pkgversion}-six
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}
%description -n python%{python3_pkgversion}-%{name}
The LSC Algorithm Library for gravitational wave data analysis.
This package provides the Python %{python3_version} bindings for LALInference.

# lalinference-octave
%package octave
Summary: Octave Bindings for LALInference
Group: LAL
Requires: lib%{name} = %{version}-%{release}
Requires: octave
Requires: lal-octave >= @MIN_LAL_VERSION@
Requires: lalframe-octave >= @MIN_LALFRAME_VERSION@
Requires: lalmetaio-octave >= @MIN_LALMETAIO_VERSION@
Requires: lalsimulation-octave >= @MIN_LALSIMULATION_VERSION@
Requires: lalburst-octave >= @MIN_LALBURST_VERSION@
Requires: lalinspiral-octave >= @MIN_LALINSPIRAL_VERSION@
Requires: lalpulsar-octave >= @MIN_LALPULSAR_VERSION@
%description octave
The LSC Algorithm Library for gravitational wave data analysis.
This package provides the Octave bindings for LALInference.

# -- build stages -----------

%prep
%setup -q -n %{name}-%{version}%{?nightly:-%{nightly}}

%build
# build C library with python3
%configure %{configure_opts} --disable-gcc-flags --enable-swig PYTHON=%{__python3}
%{__make} %{?_smp_mflags} V=1

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# build python2 library (copy things so we don't have to rebuild them)
rm -rf %pyYdir
rsync -ra . %pyYdir
pushd %pyYdir
rm -rfv python/%{name}/*.{la,lo,o} python/%{name}/.libs
%configure %{configure_opts} --disable-doxygen --disable-gcc-flags --disable-swig-octave --enable-swig-python PYTHON=%{__python2}
%{__make} V=1 -C swig
%{__make} V=1 -C python/%{name}
%{__make} V=1 -C bin bin_PROGRAMS="" dist_bin_SCRIPTS=""
popd
%endif

%check
# C + python3 + octave
%{__make} %{?_smp_mflags} V=1 VERBOSE=1 check

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
[ -d %pyYdir/test/python ] && %{__make} %{?_smp_mflags} V=1 VERBOSE=1 -C %pyYdir -C test/python check
%endif

%install
# C + python3 + octave
%make_install

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
# python2
%{__make} -C %pyYdir -C swig install-exec-am DESTDIR=%{?buildroot}
%{__make} -C %pyYdir -C python/%{name} install DESTDIR=%{?buildroot}
%endif

find $RPM_BUILD_ROOT%{_libdir} -name '*.la' -delete

%post
ldconfig

%postun
ldconfig

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -Rf ${RPM_BUILD_ROOT}
rm -Rf ${RPM_BUILD_DIR}/%{name}-%{version}%{?nightly:-%{nightly}}

# -- files ------------------

%files -n lib%{name}
%defattr(-,root,root)
%license COPYING
%{_libdir}/*.so.*

%files -n lib%{name}-devel
%defattr(-,root,root)
%license COPYING
%{_includedir}/lal
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%if 0%{?rhel} != 0 && 0%{?rhel} < 8
%files -n python2-%{name}
%defattr(-,root,root)
%license COPYING
%{python2_sitearch}/*
%endif

%files -n python%{python3_pkgversion}-%{name}
%defattr(-,root,root)
%license COPYING
%{python3_sitearch}/*

%files octave
%defattr(-,root,root)
%license COPYING
%{_prefix}/lib*/octave/*/site/oct/*/lalinference.oct*

%files
%defattr(-,root,root)
%license COPYING
%{_bindir}/*
%{_datarootdir}/%{name}/*
%{_mandir}/man1/*
%{_sysconfdir}/*

# -- changelog --------------

# dates should be formatted using: 'date +"%a %b %d %Y"'
%changelog
* Mon Jan 11 2021 Adam Mercer <adam.mercer@ligo.org> 2.0.6-1
- Update updates 2.0.6

* Wed Oct 28 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.5-1
- Update for 2.0.5

* Thu Oct 01 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.4-1
- Update to 2.0.4

* Wed Aug 05 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.3-1
- Update for 2.0.3

* Wed Jul 08 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.2-1
- Update for 2.0.2

* Mon Jun 08 2020 Adam Mercer <adam.mercer@ligo.org> 2.0.1-1
- Update for 2.0.1

* Wed Mar 25 2020 Duncan Macleod <duncan.macleod@ligo.org> 2.0.0-1
- Update for 2.0.0

* Fri Feb 21 2020 Adam Mercer <adam.mercer@ligo.org> 1.11.7-1
- O3b point release

* Thu Feb 13 2020 Adam Mercer <adam.mercer@ligo.org> 1.11.6-2
- O3b point release

* Tue Dec 17 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.5-1
- O3b point release

* Mon Dec 09 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.4-2
- Packaging updates

* Wed Nov 27 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.4-1
- O3b release

* Thu Jul 18 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.3-1
- O3 point release

* Thu Jul 11 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.2-1
- O3 point release

* Fri Jun 21 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.1-1
- O3 point release

* Tue May 21 2019 Adam Mercer <adam.mercer@ligo.org> 1.11.0-1
- O3 point release

* Wed May 01 2019 Adam Mercer <adam.mercer@ligo.org> 1.10.3-1
- O3 point release

* Mon Feb 25 2019 Adam Mercer <adam.mercer@ligo.org> 1.10.2-1
- ER14 release

* Tue Jan 22 2019 Adam Mercer <adam.mercer@ligo.org> 1.10.1-1
- Fix spin2 prior

* Thu Sep 13 2018 Adam Mercer <adam.mercer@ligo.org> 1.10.0-1
- Pre O3 release

* Thu Jul 27 2017 Adam Mercer <adam.mercer@ligo.org> 1.9.4-1
- bayestar_plot_volume: work around broken fonts in SL7

* Wed Jul 26 2017 Adam Mercer <adam.mercer@ligo.org> 1.9.3-1
- BAYESTAR and sky map post-processing updates

* Thu Mar 16 2017 Adam Mercer <adam.mercer@ligo.org> 1.9.2-1
- lalinference.io.fits: remove some redundant keys on reading
- lalinference.io.fits: fix writing single-column sky maps

* Sat Feb 18 2017 Adam Mercer <adam.mercer@ligo.org> 1.9.1-1
- Do not use $(..._la_LIBADD) to link against external libraries
- Track version info API change
- Fix to weights calculation so that posterior samples are now drawn correctly
- Fix incorrect axes limits for Mollweide sky maps
- Drop code for reading past EOF of named pipe
- Fix incorrect reordering of IDL-compatible sky maps
- Tune default max distance for volume rendering plots

* Tue Feb 07 2017 Adam Mercer <adam.mercer@ligo.org> 1.9.0-1
- O2 release

* Thu Dec 15 2016 Adam Mercer <adam.mercer@ligo.org> 1.8.2-1
- Be more emphatic about switching matplotlib backend
- Prevent trying to build python3 packages when unsupported

* Fri Dec 09 2016 Adam Mercer <adam.mercer@ligo.org> 1.8.1-1
- Explicitly set no-op Matplotlib backend
- Set matplotlib backend to no-op

* Mon Sep 26 2016 Adam Mercer <adam.mercer@ligo.org> 1.8.0-1
- ER10 release

* Thu Jun 23 2016 Adam Mercer <adam.mercer@ligo.org> 1.7.0-1
- ER9 release

* Fri Mar 25 2016 Adam Mercer <adam.mercer@ligo.org> 1.6.0-1
- Pre O2 packaging test release
